/*
 * ClientThread.java
 *
 * Created on September 12, 2003, 5:09 PM
 */

package SrvrTmplt;
import java.io.*;
import java.net.*;

    public class ClientThread extends Thread {

    InetAddress ClientIP;
    PrintWriter out = null;
    BufferedReader in = null;
    String rspnsSnt = "a";
       

    
    static String HelpMsg = "Available commands are: help, version, bye. Use extrahelp for a detailed description of each command.";
    
    /** Creates new ClientThread */
    public ClientThread(Socket ClientSock) {

        SrvrMain.ClientSock[SrvrMain.NumOfSrvrThreads] = ClientSock;
        
    }

    private void SendHelp() {
        rspnsSnt = HelpMsg;
        sendRspns();        
    }
    
    private void SendVer() {
       rspnsSnt = SrvrMain.VersionMsg;
       sendRspns();
    }
    
   private void ProcessCmds() {


        try {
            SrvrMain.ClientSock[SrvrMain.NumOfSrvrThreads - 1].setSoTimeout(SrvrMain.ClientTimeOut * 1000);
        }
        catch (SocketException e){
            SrvrMain.cmdRcvd = "bye";
            rspnsSnt = SrvrMain.TimeoutMsg;
            sendRspns();            
        }
        try {

        SrvrMain.cmdRcvd = in.readLine();
        }
        catch (IOException e) {
            SrvrMain.cmdRcvd = "bye";
            rspnsSnt = SrvrMain.TimeoutMsg;
            sendRspns();            
        }
        
            while (SrvrMain.cmdRcvd != "bye")
            {

        if (SrvrMain.cmdRcvd == null)
        break;
        else if (SrvrMain.cmdRcvd.equalsIgnoreCase("help"))
        SendHelp();
        else if (SrvrMain.cmdRcvd.equalsIgnoreCase("version")) 
        SendVer();
        else if (SrvrMain.cmdRcvd.equalsIgnoreCase("bye"))
        {
        break;
        }
        else if (SrvrMain.cmdRcvd.equalsIgnoreCase("extrahelp"))
            UserLongHelp();
        else
        {
        rspnsSnt = "unknown command, use help or extrahelp for available commands.";
        sendRspns();
        }

        try {
            SrvrMain.ClientSock[SrvrMain.NumOfSrvrThreads - 1].setSoTimeout(SrvrMain.ClientTimeOut * 1000);
        }
        catch (SocketException e){
            rspnsSnt = SrvrMain.TimeoutMsg;
            sendRspns(); 
            break;
           
        }       
        try {
        SrvrMain.cmdRcvd = in.readLine();
        }
        catch (IOException e) {
            rspnsSnt = SrvrMain.TimeoutMsg;
            sendRspns(); 
            break;
           
        }


            }
            rspnsSnt = SrvrMain.DisconnMsg;
            sendRspns();
            try {
            SrvrMain.ClientSock[SrvrMain.NumOfSrvrThreads - 1].close();

            }
            catch (IOException e){
                System.out.println(e.getMessage());
            }         

    }
    
    public void run() {
        try {
   
        in = new BufferedReader(new InputStreamReader(SrvrMain.ClientSock[SrvrMain.NumOfSrvrThreads - 1].getInputStream()));
        out = new PrintWriter(SrvrMain.ClientSock[SrvrMain.NumOfSrvrThreads - 1].getOutputStream() , true);
     
        }
        catch (IOException listenerr) {
            System.out.println(listenerr.getMessage());
        }
        

       ClientIP = SrvrMain.ClientSock[SrvrMain.NumOfSrvrThreads - 1].getInetAddress();
        SrvrMain.LogEventDescrpt = "user connected. (" + ClientIP.getHostAddress() + ")";
        SrvrMain.AddToLog();
        SrvrMain.ClientsIPs[SrvrMain.NumOfSrvrThreads - 1] = ClientIP;
        SendVer();
        rspnsSnt = SrvrMain.WelcomeMsg;
        sendRspns();
        SendHelp();
        ProcessCmds();
        SrvrMain.NumOfSrvrThreads--;
        SrvrMain.LogEventDescrpt = "user disconnected. (" + ClientIP.getHostAddress() + ")";
        SrvrMain.AddToLog();
        try {
        this.join();
        }
        catch (InterruptedException e)
        {
            System.out.println(e.getMessage());
        }
    }
    
    public void sendRspns() {
        out.println("> " + rspnsSnt );
      
        

        
    }
    
    private void UserLongHelp() {
        String helpHelp = "help\t\tprints help message.";
        String versionHelp = "version\tprints the server version.";
        String byeHelp = "bye\t\tends the current session.";
        String extrahelpHelp = "extrahelp\tprints this help message.";
        rspnsSnt = helpHelp;
        sendRspns();
        rspnsSnt = extrahelpHelp;
        sendRspns();
        rspnsSnt = versionHelp;
        sendRspns();
        rspnsSnt = byeHelp ;
        sendRspns();
    }
    
}